#include <QPainter>
#include <QDebug>
#include <QTouchEvent>
#include <QRegion>
#include "blobradialstroke.h"

int BlobRadialStroke::delayActivate = 300;
BlobRadialStroke::STATE_RADIAL BlobRadialStroke::state = CLOSED;

BlobRadialStroke::BlobRadialStroke(QWidget * _parent, bool _right) : QWidget(_parent),m_right(_right)//Qt::CustomizeWindowHint | Qt::WindowTitleHint | Qt::FramelessWindowHint )
{
    setAttribute(Qt::WA_AcceptTouchEvents);
    //setAutoFillBackground(false);
    //this->setAttribute(Qt::WA_NoSystemBackground);
    //this->setAttribute(Qt::WA_NoBackground);
    //this->setAttribute(Qt::WA_OpaquePaintEvent);
    //this->setMask(QRegion(0,0,1,1));

    //this->setWindowOpacity(0.5);
    //qDebug()<<"creation BlobRadialStroke";
    nbPreviousPoints = 0;
    origin.setP1(QPoint(0,0));
    origin.setP2(QPoint(1,0));
    origin.setAngle(3.*360./16.);
    this->setState(CLOSED);
    //    this->setWindowOpacity(0.1);
    //hide();
        valueStroke1 = valueStroke2;
}

//------------------
BlobRadialStroke::~BlobRadialStroke(){}

//------------------
void BlobRadialStroke::paintEvent ( QPaintEvent *e)
{
   // QWidget::paintEvent(e);
    QPainter p(this);

    QColor c = Qt::darkGray;
    //if(m_right) c = Qt::red;
    p.fillRect(0,0,width(),height(),c);

    p.setRenderHint(QPainter::Antialiasing);
    QPen pen(Qt::black);
    QBrush brush(Qt::white);
    p.setPen(pen);
    p.setBrush(brush);
    for(int i = 0; i<previousPoints.size();i++)
    {
        QTouchEvent::TouchPoint pt = previousPoints.at(i);
        if(pt.state()!= Qt::TouchPointReleased)
            p.drawEllipse(pt.pos(), 10,10);
        else
            p.drawEllipse(pt.pos(), 3, 3);
    }

    if(state == STROKE1 || state == STROKE2 || state == READY_STROKE2)
    {
        pen.setWidth(5);
        pen.setColor(Qt::blue);
        brush.setColor(Qt::blue);
        p.setPen(pen);
        p.setBrush(brush);
        p.drawEllipse(stroke1.p1(),15,15);
        p.drawLine(stroke1);
    }
    if(state == STROKE2)
    {
        pen.setColor(Qt::red);
        pen.setWidth(5);
        brush.setColor(Qt::red);
        p.setPen(pen);
        p.setBrush(brush);
        p.drawEllipse(stroke2.p1(),15,15);
        p.drawLine(stroke2);
    }
}

//-----------------
bool BlobRadialStroke::event(QEvent *e)
{
    if(e->type() == QEvent::TouchBegin){
        QTouchEvent *te = dynamic_cast<QTouchEvent* >(e);
        touchBegin(te);
        //qDebug()<<"touch begin";
        update();
        return true;

    }else if(e->type() == QEvent::TouchUpdate){
        QTouchEvent *te = dynamic_cast<QTouchEvent* >(e);
       touchUpdate(te);
        update();
        return true;

    }else if(e->type() == QEvent::TouchEnd){
        QTouchEvent *te = dynamic_cast<QTouchEvent* >(e);
        touchEnd(te);
        update();
        return true;
    }
        return QWidget::event(e);

}

bool BlobRadialStroke::touchBegin(QTouchEvent *e)
{
    qDebug()<<"touch begin";
    touchUpdate(e);
    return true;
}

bool BlobRadialStroke::touchUpdate(QTouchEvent *e)
{

    QList<QTouchEvent::TouchPoint> points = e->touchPoints();
        previousPoints = points;
    int nbPoints = points.size();

    //bool b = false;
    for(int i=0; i<points.size();i++)
    {
        QTouchEvent::TouchPoint pt = points.at(i);
        if(pt.state() == Qt::TouchPointReleased)
        {
            nbPoints--;
        }
    }

    if(m_right)
    {
        for(int i=0; i<points.size();i++)
        {
            bool b=false;
             QTouchEvent::TouchPoint pt = points.at(i);
             if(pt.state() == Qt::TouchPointReleased)
             {
                 b = this->release(pt);
                 nbPoints --;
             }else if(pt.state()==Qt::TouchPointPressed)
             {
                 b = this->press(pt);
             }else if(pt.state()==Qt::TouchPointMoved)
             {
                 qDebug()<<"drag";
                b = this->drag(pt);
             }
             this->update();
             //if(b)
             //{
             //   return b;
             //}
        }
        if(state==CLOSED && nbPoints ==1)
        {
            if(this->nbPreviousPoints==0)
            {
                QPoint p = this->barycenter(points);
                emit this->initBarycenter(p);
            }else
            {
                QPoint p = this->barycenter(points);
                emit this->barycenterMoved(p);
            }

        }
    }
    else
    {
        if(nbPoints==2)
        {

            if(state==CLOSED)
            {
                qDebug()<<"menu actif";
                setState(READY_STROKE1);
                emit menuOpened();
            }
        }else if(nbPoints ==1)
        {/*
            qDebug()<<"left hand nbpoints == 1";
            if(state !=CLOSED)
            {
                setState(CLOSED);
                //emit stroke1Activated(0);
                emit menuClosed();
            }
            if(this->nbPreviousPoints!=1)
            {
                QPoint p = this->barycenter(points);
                emit this->initBarycenter(p);
            }
            else
            {
                QPoint p = this->barycenter(points);
                emit this->barycenterMoved(p);
            }
            */
        }
        else if(nbPoints ==0)
        {
            qDebug()<<"left hand -> nbPoints == 0";
            if(state !=CLOSED )
            {
                qDebug()<<"left hand -> nbPoints == 0 state !=closed";
                setState(CLOSED);
                //emit stroke1Activated(0);
                emit menuClosed();
            }else
            {
             qDebug()<<"left hand -> nbPoints == 0 state ==closed";
            }
        }
    }
    this->nbPreviousPoints = nbPoints;
    update();
    return true;
}

//---------------------
bool BlobRadialStroke::press(QTouchEvent::TouchPoint pt)
{
    if(state==READY_STROKE1)
    {
        qDebug()<<"press ready stroke 1";
        //setState(STROKE1);
        valueStroke1 =-1;
        this->idStroke1 = pt.id();
        this->stroke1.setP1(pt.pos());
        this->stroke1.setP2(pt.pos());
        return true;
    }
    else if(state==READY_STROKE2)
    {
        //((STROKE2);
        valueStroke2 =-1;
        this->idStroke2 = pt.id();
        this->stroke2.setP1(pt.pos());
        this->stroke2.setP2(pt.pos());
        return true;
    }
    return false;
}

int BlobRadialStroke::numFromAngle(const QLineF& line)
{
    float degree = this->origin.angleTo(line);
    int num = (int)(degree / 360. * 8.);
    return (1+ (8- num)%8);
}

//---------------------
bool BlobRadialStroke::drag(QTouchEvent::TouchPoint pt)
{qDebug()<<"drag :: state ::"<<state;

    if(state==CLOSED)
    {

    }

    int deadZone = 20;
    if(state == READY_STROKE1){
        stroke1.setP2(pt.pos());
        qDebug()<<"stroke1.length"<<stroke1.length()<<" "<<deadZone;
        if(stroke1.length() > deadZone)
        {

            this->setState(STROKE1);
        }
    }
    else if(state==STROKE1)
    {
        if(pt.id() == idStroke1)
        {

            stroke1.setP2(pt.pos());
            int num = numFromAngle(stroke1);
            //if(num != valueStroke1){
                valueStroke1 = num;
                emit stroke1Changed(num);
            //}
            return true;
        }
    }
    else if(state == READY_STROKE2){
        this->stroke2.setP2(pt.pos());
        if(stroke2.length() > deadZone)
        {
            this->setState(STROKE2);
        }
    }
    else if(state==STROKE2)
    {
        if(pt.id() == idStroke2)
        {
            this->stroke2.setP2(pt.pos());
            int num = numFromAngle(stroke2);
            //if(num!=valueStroke2){
                valueStroke2 =num;
                emit stroke2Changed(num);
            //}
            return true;
        }
    }
    return false;
}

//---------------------
bool BlobRadialStroke::release(QTouchEvent::TouchPoint pt)
{
    if(state==STROKE1)
    {
        if(pt.id() == idStroke1)
        {
            this->stroke1.setP2(pt.pos());
            //int num = numFromAngle(stroke1);
            //emit stroke1Activated(num);
            setState(READY_STROKE2);
            return true;
        }

    }
    else if(state==STROKE2)
    {
        if(pt.id() == idStroke2)
        {
            this->stroke2.setP2(pt.pos());
            int num = numFromAngle(stroke2);

            emit stroke2Activated(num);
            emit stroke1Activated(num);
            setState(READY_STROKE1);
            return true;
        }

    }
    return false;
}

//---------------------
bool BlobRadialStroke::touchEnd(QTouchEvent * e)
{
    this->touchUpdate(e);
    this->previousPoints.clear();
    return true;
}



//--------------
QPoint BlobRadialStroke::barycenter(QList<QTouchEvent::TouchPoint>& points)
{
    QPoint res;
    for(int i=0; i<points.size();i++)
    {
        res += points.at(i).pos().toPoint()+this->pos();
    }
    if(points.size()!=0)
    {
        res/= points.size();
    }

    return res;
}

#ifdef USECMAKE
#include "blobradialstroke.moc"
#endif

