/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/


#include "minifingercount.h"
#include <QDebug>


MiniFingerCount::MiniFingerCount(QObject* parent): QObject(parent)
{
    currentFinger = 0;
}

MiniFingerCount::~MiniFingerCount()
{
    
}


//Blob Function
void MiniFingerCount::setBlob(BlobFingerCount* _blob)
{
    blob = _blob;
    connect ( blob,SIGNAL ( nbFingerAdded ( int ) ), this, SLOT ( addHandFinger ( int ) ) );
    connect ( blob,SIGNAL ( nbFingerRemoved ( int ) ), this, SLOT ( removeHandFinger ( int ) ) );
    connect ( blob,SIGNAL ( activated ( int ) ), this, SLOT ( activateHandFinger ( int ) ) );
    connect ( blob,SIGNAL ( barycenterMoved ( const QPoint& ) ),this,SLOT ( moveHand ( const QPoint&) ) );
    connect ( blob,SIGNAL ( initBarycenter ( const QPoint& ) ), this, SLOT ( resetHand ( const QPoint& ) ) );

}

void MiniFingerCount::activateHandFinger(int nbf)
{
    qDebug() << __PRETTY_FUNCTION__ ;
    activateAction(nbf);
}

void MiniFingerCount::addHandFinger(int nbf)
{
    currentFinger = nbf;
    selectAction(nbf);
}

void MiniFingerCount::moveHand(const QPoint& p)
{

}

void MiniFingerCount::removeHandFinger(int nbf)
{
    currentFinger = nbf;
    selectAction(nbf);
}

void MiniFingerCount::resetHand(const QPoint& p)
{

}



//Activation Function
QAction* MiniFingerCount::addAction(QAction* act,int fc)
{
    if (fc <=0 || fc > 10)
        return 0;
    act->setShortcut(QKeySequence(QString(fc)));
    fingerAction[fc] = act;
    return act;
}


QAction* MiniFingerCount::activateAction(int nba)
{
    QAction* act = fingerAction[nba];
    if (act)
    {
        act->trigger();
        //emit commandActivated(act->text());
        currentFinger = 0;
        //this->selectCurAction();
    }
    return act;
}

QAction* MiniFingerCount::selectAction(int nba)
{
    emit itemSelected(nba);
    QAction* act = fingerAction[nba];
    if (act)
        {}
    return act;
}


#ifdef USECMAKE
#include "minifingercount.moc"
#endif
