#ifndef QGISMT_H
#define QGISMT_H

#include <qgisplugin.h>
#include "qgismtwindow.h"

#include "qtuio.h"


#include <QObject>
#include <QAction>

class QGisMT : public QObject, public QgisPlugin {
    Q_OBJECT
public:
    QGisMT(QgisInterface *iface);
    virtual ~QGisMT();
    QgisInterface* interface() {return mIface;}
    QgsLegendInterface* legend() {return mLegendIface;}
    void initGui();
    void unload();
    static QGisMT* instance() {return mInstance;}
    static QIcon getThemeIcon(const QString name);
    static QPixmap getThemePixmap(const QString name);
    static QGisMT* mInstance ;
    
private:
    QgisInterface *mIface;
    QgsLegendInterface *mLegendIface;
    QAction *mAction;
    QGisMTWindow *window;
    QTuio tuio;
 

private slots:
    void actionPlugin();

};

#endif // QGISMT_H
