/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#include "qgismtglasslayer.h"
#include <QPainter>
#include <QRect>
#include <QPainterPath>

QGisMTGlassLayer::QGisMTGlassLayer(QWidget* parent, Qt::WindowFlags f): QWidget(parent, f)
{

}

QGisMTGlassLayer::~QGisMTGlassLayer()
{

}

bool QGisMTGlassLayer::event(QEvent* e)
{
    return QWidget::event(e);
}

void QGisMTGlassLayer::paintEvent(QPaintEvent* e)
{
    //QWidget::paintEvent(e);
    QPainter p(this);
    QColor c = Qt::red;
    c.setAlpha(80);
    /*QBrush brush(c);*/
    QPen pen(Qt::red);
    p.setPen(pen);
    p.setBrush(c);

    //QPainterPath path;
    //path.addPath(selectPath);
    //path.addPath(baryPath);
    p.drawPath(selectPath);
    c.setAlpha(0);
    p.setPen(c);
    p.setBrush(c);
    p.drawRect(QRect(QPoint(0,0),this->size()));
    pen.setWidth(5);
    pen.setColor(Qt::black);
    pen.setCapStyle(Qt::RoundCap);
    p.setPen(pen);
    p.drawPath(baryPath);
}

void QGisMTGlassLayer::drawSelectionRect(const QPoint& uL, const QPoint& dR)
{
    selectPath = QPainterPath();
    selectPath.addRect(QRect(uL,dR));
    update();
}
void QGisMTGlassLayer::drawBarycenter(const QLine & l1, const QLine & l2)
{
    baryPath = QPainterPath();
    baryPath.moveTo(l1.p1());
    baryPath.lineTo(l1.p2());
    baryPath.moveTo(l2.p1());
    baryPath.lineTo(l2.p2());
}

#ifdef USECMAKE
#include "qgismtglasslayer.moc"
#endif
