#include "qgismttoolpan.h"
#include <QPoint>
#include <QMouseEvent>

QGisMTToolPan::QGisMTToolPan(QgsMapCanvas* canvas) :
    QGisMTTool(canvas)
{
}
void QGisMTToolPan::toolAction(const QLine &l1, const QLine &l2) {
    // QPoint gp1 = l2.p1();
     QPoint lp1 = my_canvas->mapFromGlobal(l2.p1());
    // QPoint gp2 = l2.p2();
     QPoint lp2 = my_canvas->mapFromGlobal(l2.p2());
     if (toolMode == IDLE) {
         setPL(lp1);
         my_canvas->setRubberStartPoint(lp1);
         my_canvas->setMouseLastXY(lp1);
         activate();
     }
     QMouseEvent* panevent2local = new QMouseEvent(QEvent::MouseMove,lp2,Qt::NoButton,Qt::MidButton,Qt::NoModifier);
     setPR(lp2);
     my_canvas->panAction(panevent2local);
     my_canvas->setMouseLastXY(lp2);
     qDebug() << __PRETTY_FUNCTION__;
     qDebug() << "toolL : " << pL << " toolR : " << pR ;
}

void QGisMTToolPan::toolActionEnd() {
    qDebug() << __PRETTY_FUNCTION__;
    qDebug() << "toolL : " << pL << " toolR : " << pR ;
    idle();
    my_canvas->panActionEnd(pR);
}

#ifdef USECMAKE
#include "qgismttoolpan.moc"
#endif
